package com.cf.imes.module.executor.service.plan;

import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.executor.controller.admin.order.vo.order.OrderRespVO;
import com.cf.imes.module.executor.controller.admin.plan.bo.OrderRoomBodyList;
import com.cf.imes.module.executor.controller.admin.plan.vo.*;

import jakarta.validation.Valid;
import java.util.List;

/**
 * 生产单开料排单 Service 接口
 *
 * @author 晨丰科技
 */
public interface PlanService {

    /**
     * 创建生产单开料排单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    void createPlan(@Valid PlanSaveReqVO createReqVO);

    /**
     * 更新生产单开料排单
     *
     * @param updateReqVO 更新信息
     */
    void updatePlan(@Valid PlanSaveReqVO updateReqVO);

    /**
     * 删除生产单开料排单
     *
     * @param planIds 编号
     */
    void deletePlan(List<Long> planIds);

    /**
     * 获得生产单开料排单
     *
     * @param id 编号
     * @return 生产单开料排单
     */
    PlanRespVO getPlan(Long id);

    /**
     * 获得生产单开料排单分页
     *
     * @param pageReqVO 分页查询
     * @return 生产单开料排单分页
     */
    PageResult<PlanRespVO> getPlanPage(PlanPageReqVO pageReqVO);

    List<PlanRespVO> getPlanList();

    PageResult<OrderRespVOCopy> getOrderPage(OrderPageReqVOCopy pageReqVO);

    PageResult<OrderGoodsResp> getOrderGoodsPage(OrderPageReqVOCopy pageReqVO);


    PageResult<PlateResList> getPlateByPlanId(GetPlateByPlanIdVO vo);

    PageResult<OrderRespVO> getOrderByPlanId(PlanOrderPageReqVO pageReqVO);

    void setSort(List<SortVO> sortVos);

    List<PlateResList> getPlateList(List<Long> planIds);


    List<OrderRoomBodyList> getOrderRoomBody(List<Long> orderIds);

    List<PlanActualGoodsResp> getPlanGoodsList(SavePlanPlateList savePlanPlateList);

    List<PlateResList> getPlanPlateList(Long planId);

}